' A LIFO collection of {TVAL}s.
' LIFO - Last in First out, items are remove in the reverse order to which they were added.
'
'Interface i{TVAL}Stack
'
'Property Count() As Long - Get the number of items on the stack
'Property IsEmpty() as Long - True if empty, False if it has items
'Method Push( {VALREF} value As {TVAL} ) - Push an item on the stack
'Method Pop() As {TVAL} - Pop an item from the stack
'
'Method Clear() - Clear the stack
'Property Capacity() As Long - Get/Set the stack capacity

Sub New{TVAL}Stack( obj As i{TVAL}Stack, Optional capacity As Long, Optional resizeAmount As Long )
	obj = Class "c{TVAL}Stack"
	If IsFalse IsMissing( capacity ) Then
		obj.Capacity = capacity
	End If
	If IsFalse IsMissing( resizeAmount ) Then
		obj.ResizeAmount = resizeAmount
	End If
End Sub

Class c{TVAL}Stack
	Instance count_ As Long
	Instance values_() As {TVAL}
	Instance resizeAmount_ As Long

	Class Method Create()
		resizeAmount_ = 10
	End Method

	Interface i{TVAL}Stack
		Inherit IUnknown

		Property Get Count() As Long
			Property = count_
		End Property

		Property Get IsEmpty() As Long
			Property = (count_ = 0)
		End Property

		Method Push( {VALREF} value As {TVAL} )
			If count_ >= Me.Capacity Then Me.Capacity = Me.Capacity + Me.ResizeAmount
			values_( count_ ) = value
			Incr count_
		End Method

		Method Pop() As {TVAL}
			If count_ > 0 Then
				Decr count_
				Method = values_( count_ )
				Reset values_( count_ )
			End If
		End Method

		Method Clear()
			Local i As Long
			For i=0 To count_
				Reset values_( i )
			Next
			count_ = 0
		End Method

		Property Get ResizeAmount() As Long
			Property = Max&( 1, resizeAmount_ )
		End Property
		Property Set ResizeAmount( ByVal value As Long )
			If value>0 Then resizeAmount_ = value
		End Property

		Property Get Capacity() As Long
			Property = UBound( values_() )
		End Property
		Property Set Capacity( ByVal value As Long )
			If value>0 Then
				ReDim Preserve values_( value-1 )
				count_ = Min&( value, count_ )
			Else
				Erase values_()
				count_ = 0
			End If
		End Property
	End Interface
End Class
