#Compile Exe "..\pbReplace.exe"
#Compiler PBWin 10, PBCC 6
#Dim All

Global inputFile As String
Global outputFile As String
Global map As iStringStringMap

#If %Def(%PB_CC32)
Macro SHOWITEM=Con.Print
Macro NEWWIN=#Page
Macro GETINPUT=Con.Line.Input
#ElseIf %Def(%PB_Win32)
Macro SHOWITEM=Txt.Print
Macro NEWWIN=Txt.Window("Test", 10, 10) To i
Macro GETINPUT=Txt.Line.Input
#EndIf

Function PBMain () As Long
	Local filename As String
	Local k, v As String
	Local lns() As String
	Local i, cnt As Long
	Local prts() As String
	Local j, pcnt As Long
	Local e, f As Long

	fileName = Command$( 1 )
	If fileName="" Or Not IsFile( fileName ) Then
		NEWWIN
		SHOWITEM "Usage: pbReplace paramFile"
		SHOWITEM
		SHOWITEM "Press ENTER to exit"
		GETINPUT v
		Exit Function
	End If

	Call NewStringStringMap( map, 100, 10 )

	Open fileName For Binary As #1
	Get$ #1, Lof(#1), v
	Close #1

	cnt = ParseCount( v, $CrLf )
	ReDim lns(cnt-1)
	Parse v, lns(), $CrLf

	i = 0
	While i<cnt
		Select Case Left$( lns(i), 1 )
			Case ":"
				pcnt = ParseCount( lns(i), "=" )
				ReDim prts(pcnt-1)
				Parse lns(i), prts(), "="
				prts(0) = Trim$(LCase$(prts(0)))
				If pcnt>1 Then prts(1)=Trim$(prts(1))
				Select Case prts(0)
					Case ":input":  If pcnt>1 Then inputFile = prts(1)
					Case ":output": If pcnt>1 Then outputFile = prts(1)
					Case ":end":    Exit Loop
				End Select
			Case "."
				k = "{" + Mid$( lns(i),2) + "}"
				v = ""
				Incr i
				While i<cnt And Left$( lns(i), 1 )<>":" And Left$( lns(i), 1 )<>"."
					If Len(v) Then v+=$CrLf
					v+= lns(i)
					Incr i
				Wend
				Decr i
				map.Add( k, v )
		End Select
NextLoop:
		Incr i
	Wend

	If inputFile="" Or outputFile="" Then
		v = ""
		If inputFile="" Then v=" an input file"
		If outputFile="" Then
			If Len(v) Then v+=" and"
			v+= " an output file"
		End If

		NEWWIN
		SHOWITEM "pbReplace"
		SHOWITEM Build$("Parameter file {", filename, "} was missing", v )
		SHOWITEM
		SHOWITEM "Press ENTER to exit"
		GETINPUT v
		Exit Function
	End If
	If Not IsFile( inputFile ) Then
		NEWWIN
		SHOWITEM "pbReplace"
		SHOWITEM Build$( "Input file {", inputFile, "} is not a valid file." )
		SHOWITEM
		SHOWITEM "Press ENTER to exit"
		GETINPUT v
		Exit Function
	End If

	Open inputFile For Binary As #1
	Get$ #1, Lof(#1), v
	Close #1

	cnt = ParseCount( v, $CrLf )
	ReDim lns(cnt-1)
	Parse v, lns(), $CrLf

	For i=0 To cnt-1
		j = InStr( lns(i), "{" )
		While j>0
			e = InStr( j, lns(i), "}" )
			If e=0 Then Exit Loop
			v = Mid$( lns(i), j, e-j+1 )
			If v = "{CMP}" Then
				v=v
			End If
			f = map.Index( v )
			If f>-1 Then
				v = map.value( f )
				lns(i) = Left$( lns(i), j-1 ) + v + Mid$( lns(i), e+1 )
			End If
			j = InStr( j+1, lns(i), "{" )
		Wend
	Next

	Open outputFile For Output As #1
	Print #1, Join$( lns(), $CrLf );
	Close #1
End Function



Sub NewStringStringMap( obj As iStringStringMap, ByVal hashSize As Long, Optional resizeAmount As Long )
	' Passing the object to create by reference is 1) slightly faster than using a function, and 2) results in correct ref counts (functions leave an extra ref count in 10.03)
	obj = Nothing
	obj = Class "cStringStringMap"
	obj.HashCount = hashSize
	If Not IsMissing( resizeAmount ) Then
		obj.ResizeAmount = resizeAmount
	End If
End Sub

Class cStringStringMap
	Instance hash_() As Long
	Instance next_() As Long
	Instance key_() As String
	Instance value_() As String
	Instance hashCount_ As Long
	Instance dataCount_ As Long
	Instance ubData_ As Long
	Instance dataResizeAmount_ As Long

	Class Method Create()
		dataResizeAmount_ = 100
	End Method

	Interface iStringStringMap
		Inherit IUnknown

		Property Get HashCount() As Long
			Property = hashCount_
		End Property
		Property Set HashCount( value As Long )
			Me.ResizeHash( value )
		End Property

		Property Get ResizeAmount() As Long
			Property = dataResizeAmount_
		End Property
		Property Set ResizeAmount( ByVal value As Long )
			If value>0 Then dataResizeAmount_ = value
		End Property

		Property Get Count() As Long
			Property = dataCount_
		End Property
		Property Set Count( ByVal value As Long )
			If value> dataCount_ Then Me.ResizeData( value )
		End Property

		Method Clear()
			Me.ResizeHash( 0 )
			Me.ResizeData( 0 )
		End Method

		' Returns index of added item
		Method Add( pKey As String, value As String ) As Long
			Register index As Long
			Register lastIndex As Long
			Local hc As Long
			Local np As Long Ptr

			' Notes: Long returns from functions are OK.
			' String returns better passed to sub by reference (like 3 times slower from function)
			hc = StringHash( pKey, hashCount_ ): ' Would be faster inline, but instance variable access from ASM I'm not sure I understand yet.

			index = hash_( hc )

			If index = -1 Then
				' First entry
				If dataCount_>=ubData_-1 Then Me.ResizeData( ubData_+dataResizeAmount_ )
				hash_( hc ) = dataCount_
			Else
				' Collision
				np = VarPtr( next_(0) )
				Do
					If StrStrICmp( pKey, key_( index ) ) Then
						lastIndex = index
						index = @np[ index ]
						'index = next_( index )
					Else
						Method = index
						Exit Method
					End If
				Loop While index>-1
				If dataCount_>=ubData_-1 Then Me.ResizeData( ubData_+dataResizeAmount_ )
				next_( lastIndex ) = dataCount_
			End If
			next_( dataCount_ ) = -1
			key_( dataCount_ ) = pKey
			value_( dataCount_ ) = value
			Method = dataCount_
			Incr dataCount_
		End Method

		' -1 if found, 0 if not found
		Property Get Contains( pKey As String ) As Long
			' Cost .04 second for a million lookups to use the function instead of inlining it
			Property = ( Me.Index( pKey ) > -1 )
		End Property

		Property Get Index( pKey As String ) As Long
			' Returns index of key
			' Returns -1 if not found
			' Returns 0 - dataCount_-1 if found
			Register index As Long
			Local hc As Long

			hc = StringHash( pKey, hashCount_ )
			index = hash_( hc )

			While index > -1
				If StrStrICmp( pKey, key_( index ) ) Then
					index = next_( index )
				Else
					Property = index
					Exit Property
				End If
			Wend
			Property = -1
		End Property

		Property Get Key( ByVal index As Long ) As String
			If index>=0 And index< dataCount_ Then
				Property = key_( index )
			End If
		End Property

		Property Get Value( ByVal index As Long ) As String
			If index>=0 And index<dataCount_ Then
				Property = value_( index )
			End If
		End Property
		Property Set Value( ByVal index As Long, sf As String )
			If index>=0 And index<dataCount_ Then
				value_( index ) = "": ' Ensure ref count ok (PB 10.03)
				value_( index ) = sf
			End If
		End Property

		Property Get Item( pKey As String ) As String
			Local index As Long
			index = Me.Index( pKey )
			If index>-1 Then Property = value_( index )
		End Property
		Property Set Item( pKey As String, value As String )
			Local index As Long
			index = Me.Index( pKey )
			If index>-1 Then
				value_( index ) = value
			End If
		End Property
	End Interface

	Class Method ResizeData( ByVal value As Long )
		If value>0 Then
			ReDim Preserve next_( value-1 )
			ReDim Preserve key_( value-1 )
			ReDim Preserve value_( value-1 )
			ubData_ = value
			dataCount_ = Min&( ubData_-1, dataCount_ )
		Else
			Erase next_()
			Erase key_()
			Erase value_()
			ubData_ = 0
			dataCount_ = 0
		End If
	End Method

	Class Method ResizeHash( ByVal value As Long )
		value = CollectionSize( value ): ' Make a prime >= value
		ReDim hash_( value-1 )
		Memory Fill VarPtr( hash_(0) ), value*SizeOf(value), Byte &HFF
		hashCount_ = value
	End Method
End Class

' Lower case translation table
AsmData LowerCaseBytes
	DB &H00, &H01, &H02, &H03, &H04, &H05, &H06, &H07, &H08, &H09, &H0A, &H0B, &H0C, &H0D, &H0E, &H0F
	DB &H10, &H11, &H12, &H13, &H14, &H15, &H16, &H17, &H18, &H19, &H1A, &H1B, &H1C, &H1D, &H1E, &H1F
	DB &H20, &H21, &H22, &H23, &H24, &H25, &H26, &H27, &H28, &H29, &H2A, &H2B, &H2C, &H2D, &H2E, &H2F
	DB &H30, &H31, &H32, &H33, &H34, &H35, &H36, &H37, &H38, &H39, &H3A, &H3B, &H3C, &H3D, &H3E, &H3F
	DB &H40, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H5B, &H5C, &H5D, &H5E, &H5F
	DB &H60, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H7B, &H7C, &H7D, &H7E, &H7F
	DB &H80, &H81, &H82, &H83, &H84, &H85, &H86, &H87, &H88, &H89, &H9A, &H8B, &H9C, &H8D, &H9E, &H8F
	DB &H90, &H91, &H92, &H93, &H94, &H95, &H96, &H97, &H98, &H99, &H9A, &H9B, &H9C, &H9D, &H9E, &HFF
	DB &HA0, &HA1, &HA2, &HA3, &HA4, &HA5, &HA6, &HA7, &HA8, &HA9, &HAA, &HAB, &HAC, &HAD, &HAE, &HAF
	DB &HB0, &HB1, &HB2, &HB3, &HB4, &HB5, &HB6, &HB7, &HB8, &HB9, &HBA, &HBB, &HBC, &HBD, &HBE, &HBF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HD7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HDF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HF7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HFF
End AsmData

Function StringHash( value As String, ByVal hashSize As Long ) As Long
	#Debug Code Off
	' Case insenstive string hash function
	! MOV ESI, value
	! MOV ESI, [ESI]            ; ESI = StrPtr( value )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! MOV ECX, 1                ; Seed
StringHash_Loop:
	! MOVZX EAX, BYTE PTR[ESI]  ; Load byte
	! OR EAX, EAX
	! JZ StringHash_End         ; While @pValue[ i ]
	! XLATB                     ; Lower case version of byte
	! ROL ECX, 3                ; ECX *= 1048576
	! ADD ECX, EAX              ; ECX += @pValue[ i ]
	! INC ESI                   ; Inc i
	! JMP StringHash_Loop       ; Wend
StringHash_End:
	! MOV EBX, hashSize         ; EBX = hashSize
	! MOV EAX, ECX              ; EAX = hc
	! XOR EDX, EDX              ; EDX = 0, forces divident to positive number
	! DIV EBX                   ; EDX:EAX /= hashSize
	! MOV Function, EDX         ; Function = hc Mod hashSize
	#Debug Code On
End Function

Function StrStrICmp( aValue As String, bValue As String ) As Long
	#Debug Code Off
	' Returns
	'   If a = b then 0
	'   If a < b Then a negative number
	'   If a > b Then a positive number
	! MOV  ESI, aValue
	! MOV  ESI, [ESI]           ; ESI = StrPtr( aValue )
	! MOV  EDI, bValue
	! MOV  EDI, [EDI]           ; EDI = StrPtr( bValue )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! XOR EAX, EAX              ; EAX = 0
StriCmp_Loop:
	! MOV AL, BYTE PTR[EDI]     ; AL = @b
	! XLATB                     ; AL = LCase$( @b )
	! MOV ECX, EAX              ; ECX = LCase$( @b )
	! MOV AL, BYTE PTR[ESI]     ; EAX = @a
	! XLATB                     ; EAX = LCase$( @a )
	! SUB EAX, ECX              ; res = EAX - ECX
	! JNZ StriCmp_Exit          ; if res<>0 Then Exit
	! OR ECX, ECX               ; If @b = 0
	! JZ SHORT StriCmp_Exit     ; Then Exit
	! INC EDI                   ; Incr b
	! INC ESI                   ; Incr a
	! JMP SHORT StriCmp_Loop    ; Wend
StriCmp_Exit:
	! MOV FUNCTION, EAX         ; Function = LCase$( @a ) - LCase$( @b )
	#Debug Code On
End Function

AsmData PrimeCollectionSizes
	DD 17, 37, 67, 131, 257, 521, 1031, 2053
	DD 4099, 8209, 16411, 32771, 65537
	DD 131101, 262147, 524309, 1048583
	DD 2097169, 4194319, 8388617, 16777259
	DD 33554467, 67108879, 134217757
	DD 268435459, 536870923, 1073741827
End AsmData

Function CollectionSize( ByVal capacity As Long ) As Long
	Register i As Long
	Register l As Long
	Local h As Long
	Local primes As Long Ptr

	primes = CodePtr( PrimeCollectionSizes )

	'l = 0: ' l already 0
	h = 26  ' 27 prime values in table (0-26)
	While l+1<h
		i = (l+h)
		Shift Right i, 1
		If @primes[i] = capacity Then
			Function = @primes[i]
			Exit Function
		ElseIf @primes[i] < capacity Then
			l = i
		Else
			h = i
		End If
	Wend

	If @primes[l]>=capacity Then
		Function = @primes[l]
	Else
		Function = @primes[h]
	End If
End Function
