' Lower case translation table
AsmData LowerCaseBytes
	DB &H00, &H01, &H02, &H03, &H04, &H05, &H06, &H07, &H08, &H09, &H0A, &H0B, &H0C, &H0D, &H0E, &H0F
	DB &H10, &H11, &H12, &H13, &H14, &H15, &H16, &H17, &H18, &H19, &H1A, &H1B, &H1C, &H1D, &H1E, &H1F
	DB &H20, &H21, &H22, &H23, &H24, &H25, &H26, &H27, &H28, &H29, &H2A, &H2B, &H2C, &H2D, &H2E, &H2F
	DB &H30, &H31, &H32, &H33, &H34, &H35, &H36, &H37, &H38, &H39, &H3A, &H3B, &H3C, &H3D, &H3E, &H3F
	DB &H40, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H5B, &H5C, &H5D, &H5E, &H5F
	DB &H60, &H61, &H62, &H63, &H64, &H65, &H66, &H67, &H68, &H69, &H6A, &H6B, &H6C, &H6D, &H6E, &H6F
	DB &H70, &H71, &H72, &H73, &H74, &H75, &H76, &H77, &H78, &H79, &H7A, &H7B, &H7C, &H7D, &H7E, &H7F
	DB &H80, &H81, &H82, &H83, &H84, &H85, &H86, &H87, &H88, &H89, &H9A, &H8B, &H9C, &H8D, &H9E, &H8F
	DB &H90, &H91, &H92, &H93, &H94, &H95, &H96, &H97, &H98, &H99, &H9A, &H9B, &H9C, &H9D, &H9E, &HFF
	DB &HA0, &HA1, &HA2, &HA3, &HA4, &HA5, &HA6, &HA7, &HA8, &HA9, &HAA, &HAB, &HAC, &HAD, &HAE, &HAF
	DB &HB0, &HB1, &HB2, &HB3, &HB4, &HB5, &HB6, &HB7, &HB8, &HB9, &HBA, &HBB, &HBC, &HBD, &HBE, &HBF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HD7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HDF
	DB &HE0, &HE1, &HE2, &HE3, &HE4, &HE5, &HE6, &HE7, &HE8, &HE9, &HEA, &HEB, &HEC, &HED, &HEE, &HEF
	DB &HF0, &HF1, &HF2, &HF3, &HF4, &HF5, &HF6, &HF7, &HF8, &HF9, &HFA, &HFB, &HFC, &HFD, &HFE, &HFF
End AsmData

'===============================================================
' Case insensitive routines
'===============================================================
Function StrIHash( value As String, ByVal hashSize As Long ) As Long
	#Debug Code Off
	' Case insenstive string hash function
	! MOV ESI, value
	! MOV ESI, [ESI]            ; ESI = StrPtr( value )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! MOV ECX, 1                ; Seed
StrIHash_Loop:
	! MOVZX EAX, BYTE PTR[ESI]  ; Load byte
	! OR EAX, EAX
	! JZ StrIHash_End           ; While @pValue[ i ]
	! XLATB                     ; Lower case version of byte
	! ROL ECX, 3                ; ECX *= 1048576
	! ADD ECX, EAX              ; ECX += @pValue[ i ]
	! INC ESI                   ; Inc i
	! JMP StrIHash_Loop         ; Wend
StrIHash_End:
	! MOV EBX, hashSize         ; EBX = hashSize
	! MOV EAX, ECX              ; EAX = hc
	! XOR EDX, EDX              ; EDX = 0, forces divident to positive number
	! DIV EBX                   ; EDX:EAX /= hashSize
	! MOV Function, EDX         ; Function = hc Mod hashSize
	#Debug Code On
End Function

Function StrStrICmp( aValue As String, bValue As String ) As Long
	#Debug Code Off
	' Returns
	'   If a = b then 0
	'   If a < b Then a negative number
	'   If a > b Then a positive number
	! MOV  ESI, aValue
	! MOV  ESI, [ESI]           ; ESI = StrPtr( aValue )
	! MOV  EDI, bValue
	! MOV  EDI, [EDI]           ; EDI = StrPtr( bValue )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! XOR EAX, EAX              ; EAX = 0
StriCmp_Loop:
	! MOV AL, BYTE PTR[EDI]     ; AL = @b
	! XLATB                     ; AL = LCase$( @b )
	! MOV ECX, EAX              ; ECX = LCase$( @b )
	! MOV AL, BYTE PTR[ESI]     ; EAX = @a
	! XLATB                     ; EAX = LCase$( @a )
	! SUB EAX, ECX              ; res = EAX - ECX
	! JNZ StriCmp_Exit          ; if res<>0 Then Exit
	! OR ECX, ECX               ; If @b = 0
	! JZ SHORT StriCmp_Exit     ; Then Exit
	! INC EDI                   ; Incr b
	! INC ESI                   ; Incr a
	! JMP SHORT StriCmp_Loop    ; Wend
StriCmp_Exit:
	! MOV FUNCTION, EAX         ; Function = LCase$( @a ) - LCase$( @b )
	#Debug Code On
End Function

'===============================================================
' Case sensitive routines
'===============================================================
Function StrHash( value As String, ByVal hashSize As Long ) As Long
	#Debug Code Off
	' Case senstive string hash function
	! MOV ESI, value
	! MOV ESI, [ESI]            ; ESI = StrPtr( value )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! MOV ECX, 1                ; Seed
StrHash_Loop:
	! MOVZX EAX, BYTE PTR[ESI]  ; Load byte
	! OR EAX, EAX
	! JZ StrHash_End            ; While @pValue[ i ]
	! ROL ECX, 3                ; ECX *= 1048576
	! ADD ECX, EAX              ; ECX += @pValue[ i ]
	! INC ESI                   ; Inc i
	! JMP StrHash_Loop          ; Wend
StrHash_End:
	! MOV EBX, hashSize         ; EBX = hashSize
	! MOV EAX, ECX              ; EAX = hc
	! XOR EDX, EDX              ; EDX = 0, forces divident to positive number
	! DIV EBX                   ; EDX:EAX /= hashSize
	! MOV Function, EDX         ; Function = hc Mod hashSize
	#Debug Code On
End Function

Function StrStrCmp( aValue As String, bValue As String ) As Long
	#Debug Code Off
	' Case sensitive string to string compare
	' Returns
	'   If a = b then 0
	'   If a < b Then a negative number
	'   If a > b Then a positive number
	! MOV  ESI, aValue
	! MOV  ESI, [ESI]           ; ESI = StrPtr( aValue )
	! MOV  EDI, bValue
	! MOV  EDI, [EDI]           ; EDI = StrPtr( bValue )
	! LEA EBX, LowerCaseBytes   ; Translate table
	! XOR EAX, EAX              ; EAX = 0
StriCmp_Loop:
	! MOV AL, BYTE PTR[EDI]     ; AL = @b
	! MOV ECX, EAX              ; ECX = @b
	! MOV AL, BYTE PTR[ESI]     ; EAX = @a
	! SUB EAX, ECX              ; res = EAX - ECX
	! JNZ StriCmp_Exit          ; if res<>0 Then Exit
	! OR ECX, ECX               ; If @b = 0
	! JZ SHORT StriCmp_Exit     ; Then Exit
	! INC EDI                   ; Incr b
	! INC ESI                   ; Incr a
	! JMP SHORT StriCmp_Loop    ; Wend
StriCmp_Exit:
	! MOV FUNCTION, EAX         ; Function = LCase$( @a ) - LCase$( @b )
	#Debug Code On
End Function
